//
//  CHUserDefaults.h
//  Chocolat
//
//  Created by Pieter Omvlee on 18/12/2009.
//  Copyright 2009 Bohemian Coding. All rights reserved.
//

#import <Cocoa/Cocoa.h>

FOUNDATION_STATIC_INLINE id CHDefaults()
{
  return [[NSUserDefaultsController sharedUserDefaultsController] defaults];
}

FOUNDATION_STATIC_INLINE BOOL CHDefaultsBoolForKey(NSString *key)
{
  return [CHDefaults() boolForKey:key];
}

FOUNDATION_STATIC_INLINE NSInteger CHDefaultsIntegerForKey(NSString *key)
{
  return [CHDefaults() integerForKey:key];
}

FOUNDATION_STATIC_INLINE CGFloat CHDefaultsFloatForKey(NSString *key)
{
  return [CHDefaults() floatForKey:key];
}

FOUNDATION_STATIC_INLINE id CHDefaultsValueForKey(NSString *key)
{
  return [CHDefaults() valueForKey:key];
}

#pragma mark -

FOUNDATION_STATIC_INLINE void CHDefaultsSetFloatForKey(CGFloat f, NSString *key)
{
  [CHDefaults() setFloat:f forKey:key];
}

FOUNDATION_STATIC_INLINE void CHDefaultsSetIntegerForKey(NSInteger integer, NSString *key)
{
  [CHDefaults() setInteger:integer forKey:key];
}

FOUNDATION_STATIC_INLINE void CHDefaultsSetBoolForKey(BOOL flag, NSString *key)
{
  [CHDefaults() setBool:flag forKey:key];
}

FOUNDATION_STATIC_INLINE void CHDefaultsSetValueForKey(id value, NSString *key)
{
  [CHDefaults() setValue:value forKey:key];
}
