//Created By Pieter Omvlee on 24-11-06
#import <QuartzCore/QuartzCore.h>
#import <Cocoa/Cocoa.h>
#import <Chocolat/Chocolat.h>

#import "MSFilter.h"
#import "MSParentSelect.h"
#import "MSFilterInfo.h"
#import "MSDummyFilter.h"

@interface MSFilterController : MSParentSelect <NSCopying>
{
  id delegate;
  id controller;
  
  NSArray *undoArray;
}
+ (NSMenu *)allFiltersMenu:(id)sender selector:(SEL)sel;

/* Roep deze methode aan om de gebruikte filters aan anImage toe te voegen. Returnt een kopie van het image met de filters */
- (id)renderImage:(id)coreImage innerFrame:(NSRect)f specialCase:(BOOL)b;

/* Voeg een filter met een bepaalde naam toe, de naam mag zowel bv CIGaussianBlur zijn als Gaussian Blur */
- (id)addFilterWithName:(NSString *)name;
- (void)removeFilterWithName:(NSString *)name;
- (void)removeFilter:(id)filter;
- (void)removeAllFilters;

- (MSFilter *)filterWithName:(NSString *)name;

- (void)setFilters:(NSMutableArray *)filters withUndo:(BOOL)undo;

- (NSMutableArray *)filters;//return alle filters

- (void)sendUpdate;
- (void)sendFilterUpdate:(BOOL)b;

- (id)delegate;
- (void)setDelegate:(id)aValue;

- (NSUndoManager *)undoManager;

- (id)controller;
- (void)setController:(id)aValue;

- (IBAction)addFilterAction:(id)sender;

- (void)removeChildWithUndo:(id)filter;

- (void)recordBeforeDrag;
- (void)restoreFromDrag;
- (void)recordUndoAfterDrag;

//private
- (void)switchBetweenFilters:(NSArray *)filters1 andFilters:(NSArray *)filters2;
- (void)removeInvisibleFilters;

+ (NSMenu *)filtersMenuForCategory:(NSString *)officialName target:(id)target selector:(SEL)sel;

- (void)_addChild:(id)aChild;
- (void)_removeChild:(id)aChild;
- (id)undoInvocation;
@end

@interface NSObject (MSFilterControllerDelegate)
- (void)filterController:(MSFilterController *)fc selectedFilter:(MSFilter *)fl;
- (void)filterController:(MSFilterController *)fc removedFilter:(MSFilter *)fl;

- (NSBezierPath *)bezierBoundsForFilterController:(MSFilterController *)fc;
- (BOOL)usesBorderImageForFilterController:(MSFilterController *)fc;
- (BOOL)borderIsThinLine;
@end
